import {Component, OnDestroy, OnInit} from '@angular/core';
import {TransactionService} from '../../_services/transaction.service';
import {Conversion, Transaction} from '../../_models';
import {Subject} from 'rxjs';

@Component({
  selector: 'app-transactions',
  templateUrl: './transactions.component.html',
  styleUrls: ['./transactions.component.scss']
})
export class TransactionsComponent implements OnInit, OnDestroy {
  dtOptions: DataTables.Settings = {};
  dtTrigger: Subject<any> = new Subject();
  transactions: Transaction[] = [];
  conversions: Conversion[] = [];
  transaction: Transaction;
  conversion: Conversion;

  constructor(private transactionService: TransactionService) { }

  ngOnInit(): void {
    this.dtOptions = {
      pagingType: 'full_numbers',
      pageLength: 5,
      lengthMenu: [5, 10, 25, 50, 100],
      processing: true
    };

    this.transactions = this.transactionService.transactions;
    this.conversions = this.transactionService.conversions;
    this.dtTrigger.next();
  }

  ngOnDestroy(): void {
    this.dtTrigger.unsubscribe();
  }

  viewTransaction(transaction): void {
    this.transaction = transaction;
  }

  viewConversion(conversion): void {
    this.conversion = conversion;
  }
}
